Index: apps/app_voicemail.c
===================================================================
RCS file: /usr/cvsroot/asterisk/apps/app_voicemail.c,v
retrieving revision 1.200
diff -u -r1.200 app_voicemail.c
--- apps/app_voicemail.c	19 Feb 2005 16:34:45 -0000	1.200
+++ apps/app_voicemail.c	28 Feb 2005 17:10:59 -0000
@@ -4436,15 +4436,20 @@
 		logretries++;
 		if (!valid) {
 			if (skipuser || logretries >= maxlogins) {
-				if (ast_streamfile(chan, "vm-incorrect", chan->language))
-					break;
+				if (ast_streamfile(chan, "vm-incorrect", chan->language)) {
+					ast_log(LOG_WARNING, "Unable to stream incorrect message\n");
+					return -1;
+				}
 			} else {
 				if (useadsi)
 					adsi_login(chan);
-				if (ast_streamfile(chan, "vm-incorrect-mailbox", chan->language))
-					break;
+				if (ast_streamfile(chan, "vm-incorrect-mailbox", chan->language)) {
+					ast_log(LOG_WARNING, "Unable to stream incorrect mailbox message\n");
+					return -1;
+				}
 			}
-			ast_waitstream(chan, "");
+			if (ast_waitstream(chan, ""))	/* Channel is hung up */
+				return -1;
 		}
 	}
 	if (!valid && (logretries >= maxlogins)) {
